42e0e9f63df06453a1515ceaa33b9431c966a23f
1#!/bin/sh
2#
3# git-submodule.sh: add, init, update or list git submodules
4#
5# Copyright (c) 2007 Lars Hjemli
6
7dashless=$(basename "$0" | sed -e 's/-/ /')
8USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--[no-]recommend-shallow] [--reference <repository>] [--recursive] [--] [<path>...]
13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
14 or: $dashless [--quiet] foreach [--recursive] <command>
15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]"
16OPTIONS_SPEC=
17SUBDIRECTORY_OK=Yes
18. git-sh-setup
19. git-sh-i18n
20. git-parse-remote
21require_work_tree
22wt_prefix=$(git rev-parse --show-prefix)
23cd_to_toplevel
24
25# Restrict ourselves to a vanilla subset of protocols; the URLs
26# we get are under control of a remote repository, and we do not
27# want them kicking off arbitrary git-remote-* programs.
28#
29# If the user has already specified a set of allowed protocols,
30# we assume they know what they're doing and use that instead.
31: ${GIT_ALLOW_PROTOCOL=file:git:http:https:ssh}
32export GIT_ALLOW_PROTOCOL
33
34command=
35branch=
36force=
37reference=
38cached=
39recursive=
40init=
41files=
42remote=
43nofetch=
44update=
45prefix=
46custom_name=
47depth=
48
49# Resolve a path to be relative to another path. This is intended for
50# converting submodule paths when git-submodule is run in a subdirectory
51# and only handles paths where the directory separator is '/'.
52#
53# The output is the first argument as a path relative to the second argument,
54# which defaults to $wt_prefix if it is omitted.
55relative_path ()
56{
57 local target curdir result
58 target=$1
59 curdir=${2-$wt_prefix}
60 curdir=${curdir%/}
61 result=
62
63 while test -n "$curdir"
64 do
65 case "$target" in
66 "$curdir/"*)
67 target=${target#"$curdir"/}
68 break
69 ;;
70 esac
71
72 result="${result}../"
73 if test "$curdir" = "${curdir%/*}"
74 then
75 curdir=
76 else
77 curdir="${curdir%/*}"
78 fi
79 done
80
81 echo "$result$target"
82}
83
84die_if_unmatched ()
85{
86 if test "$1" = "#unmatched"
87 then
88 exit 1
89 fi
90}
91
92#
93# Print a submodule configuration setting
94#
95# $1 = submodule name
96# $2 = option name
97# $3 = default value
98#
99# Checks in the usual git-config places first (for overrides),
100# otherwise it falls back on .gitmodules. This allows you to
101# distribute project-wide defaults in .gitmodules, while still
102# customizing individual repositories if necessary. If the option is
103# not in .gitmodules either, print a default value.
104#
105get_submodule_config () {
106 name="$1"
107 option="$2"
108 default="$3"
109 value=$(git config submodule."$name"."$option")
110 if test -z "$value"
111 then
112 value=$(git config -f .gitmodules submodule."$name"."$option")
113 fi
114 printf '%s' "${value:-$default}"
115}
116
117isnumber()
118{
119 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
120}
121
122# Sanitize the local git environment for use within a submodule. We
123# can't simply use clear_local_git_env since we want to preserve some
124# of the settings from GIT_CONFIG_PARAMETERS.
125sanitize_submodule_env()
126{
127 save_config=$GIT_CONFIG_PARAMETERS
128 clear_local_git_env
129 GIT_CONFIG_PARAMETERS=$save_config
130 export GIT_CONFIG_PARAMETERS
131}
132
133#
134# Add a new submodule to the working tree, .gitmodules and the index
135#
136# $@ = repo path
137#
138# optional branch is stored in global branch variable
139#
140cmd_add()
141{
142 # parse $args after "submodule ... add".
143 reference_path=
144 while test $# -ne 0
145 do
146 case "$1" in
147 -b | --branch)
148 case "$2" in '') usage ;; esac
149 branch=$2
150 shift
151 ;;
152 -f | --force)
153 force=$1
154 ;;
155 -q|--quiet)
156 GIT_QUIET=1
157 ;;
158 --reference)
159 case "$2" in '') usage ;; esac
160 reference_path=$2
161 shift
162 ;;
163 --reference=*)
164 reference_path="${1#--reference=}"
165 ;;
166 --name)
167 case "$2" in '') usage ;; esac
168 custom_name=$2
169 shift
170 ;;
171 --depth)
172 case "$2" in '') usage ;; esac
173 depth="--depth=$2"
174 shift
175 ;;
176 --depth=*)
177 depth=$1
178 ;;
179 --)
180 shift
181 break
182 ;;
183 -*)
184 usage
185 ;;
186 *)
187 break
188 ;;
189 esac
190 shift
191 done
192
193 if test -n "$reference_path"
194 then
195 is_absolute_path "$reference_path" ||
196 reference_path="$wt_prefix$reference_path"
197
198 reference="--reference=$reference_path"
199 fi
200
201 repo=$1
202 sm_path=$2
203
204 if test -z "$sm_path"; then
205 sm_path=$(printf '%s\n' "$repo" |
206 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
207 fi
208
209 if test -z "$repo" || test -z "$sm_path"; then
210 usage
211 fi
212
213 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
214
215 # assure repo is absolute or relative to parent
216 case "$repo" in
217 ./*|../*)
218 test -z "$wt_prefix" ||
219 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
220
221 # dereference source url relative to parent's url
222 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
223 ;;
224 *:*|/*)
225 # absolute url
226 realrepo=$repo
227 ;;
228 *)
229 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
230 ;;
231 esac
232
233 # normalize path:
234 # multiple //; leading ./; /./; /../; trailing /
235 sm_path=$(printf '%s/\n' "$sm_path" |
236 sed -e '
237 s|//*|/|g
238 s|^\(\./\)*||
239 s|/\(\./\)*|/|g
240 :start
241 s|\([^/]*\)/\.\./||
242 tstart
243 s|/*$||
244 ')
245 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
246 die "$(eval_gettext "'\$sm_path' already exists in the index")"
247
248 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
249 then
250 eval_gettextln "The following path is ignored by one of your .gitignore files:
251\$sm_path
252Use -f if you really want to add it." >&2
253 exit 1
254 fi
255
256 if test -n "$custom_name"
257 then
258 sm_name="$custom_name"
259 else
260 sm_name="$sm_path"
261 fi
262
263 # perhaps the path exists and is already a git repo, else clone it
264 if test -e "$sm_path"
265 then
266 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
267 then
268 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
269 else
270 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
271 fi
272
273 else
274 if test -d ".git/modules/$sm_name"
275 then
276 if test -z "$force"
277 then
278 echo >&2 "$(eval_gettext "A git directory for '\$sm_name' is found locally with remote(s):")"
279 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
280 echo >&2 "$(eval_gettext "If you want to reuse this local git directory instead of cloning again from")"
281 echo >&2 " $realrepo"
282 echo >&2 "$(eval_gettext "use the '--force' option. If the local git directory is not the correct repo")"
283 die "$(eval_gettext "or you are unsure what this means choose another name with the '--name' option.")"
284 else
285 echo "$(eval_gettext "Reactivating local git directory for submodule '\$sm_name'.")"
286 fi
287 fi
288 git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${depth:+"$depth"} || exit
289 (
290 sanitize_submodule_env
291 cd "$sm_path" &&
292 # ash fails to wordsplit ${branch:+-b "$branch"...}
293 case "$branch" in
294 '') git checkout -f -q ;;
295 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
296 esac
297 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
298 fi
299 git config submodule."$sm_name".url "$realrepo"
300
301 git add $force "$sm_path" ||
302 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
303
304 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
305 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
306 if test -n "$branch"
307 then
308 git config -f .gitmodules submodule."$sm_name".branch "$branch"
309 fi &&
310 git add --force .gitmodules ||
311 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
312}
313
314#
315# Execute an arbitrary command sequence in each checked out
316# submodule
317#
318# $@ = command to execute
319#
320cmd_foreach()
321{
322 # parse $args after "submodule ... foreach".
323 while test $# -ne 0
324 do
325 case "$1" in
326 -q|--quiet)
327 GIT_QUIET=1
328 ;;
329 --recursive)
330 recursive=1
331 ;;
332 -*)
333 usage
334 ;;
335 *)
336 break
337 ;;
338 esac
339 shift
340 done
341
342 toplevel=$(pwd)
343
344 # dup stdin so that it can be restored when running the external
345 # command in the subshell (and a recursive call to this function)
346 exec 3<&0
347
348 git submodule--helper list --prefix "$wt_prefix"|
349 while read mode sha1 stage sm_path
350 do
351 die_if_unmatched "$mode"
352 if test -e "$sm_path"/.git
353 then
354 displaypath=$(relative_path "$prefix$sm_path")
355 say "$(eval_gettext "Entering '\$displaypath'")"
356 name=$(git submodule--helper name "$sm_path")
357 (
358 prefix="$prefix$sm_path/"
359 sanitize_submodule_env
360 cd "$sm_path" &&
361 sm_path=$(relative_path "$sm_path") &&
362 # we make $path available to scripts ...
363 path=$sm_path &&
364 if test $# -eq 1
365 then
366 eval "$1"
367 else
368 "$@"
369 fi &&
370 if test -n "$recursive"
371 then
372 cmd_foreach "--recursive" "$@"
373 fi
374 ) <&3 3<&- ||
375 die "$(eval_gettext "Stopping at '\$displaypath'; script returned non-zero status.")"
376 fi
377 done
378}
379
380#
381# Register submodules in .git/config
382#
383# $@ = requested paths (default to all)
384#
385cmd_init()
386{
387 # parse $args after "submodule ... init".
388 while test $# -ne 0
389 do
390 case "$1" in
391 -q|--quiet)
392 GIT_QUIET=1
393 ;;
394 --)
395 shift
396 break
397 ;;
398 -*)
399 usage
400 ;;
401 *)
402 break
403 ;;
404 esac
405 shift
406 done
407
408 git ${wt_prefix:+-C "$wt_prefix"} submodule--helper init ${GIT_QUIET:+--quiet} ${prefix:+--prefix "$prefix"} "$@"
409}
410
411#
412# Unregister submodules from .git/config and remove their work tree
413#
414# $@ = requested paths (use '.' to deinit all submodules)
415#
416cmd_deinit()
417{
418 # parse $args after "submodule ... deinit".
419 deinit_all=
420 while test $# -ne 0
421 do
422 case "$1" in
423 -f|--force)
424 force=$1
425 ;;
426 -q|--quiet)
427 GIT_QUIET=1
428 ;;
429 --all)
430 deinit_all=t
431 ;;
432 --)
433 shift
434 break
435 ;;
436 -*)
437 usage
438 ;;
439 *)
440 break
441 ;;
442 esac
443 shift
444 done
445
446 if test -n "$deinit_all" && test "$#" -ne 0
447 then
448 echo >&2 "$(eval_gettext "pathspec and --all are incompatible")"
449 usage
450 fi
451 if test $# = 0 && test -z "$deinit_all"
452 then
453 die "$(eval_gettext "Use '--all' if you really want to deinitialize all submodules")"
454 fi
455
456 git submodule--helper list --prefix "$wt_prefix" "$@" |
457 while read mode sha1 stage sm_path
458 do
459 die_if_unmatched "$mode"
460 name=$(git submodule--helper name "$sm_path") || exit
461
462 displaypath=$(relative_path "$sm_path")
463
464 # Remove the submodule work tree (unless the user already did it)
465 if test -d "$sm_path"
466 then
467 # Protect submodules containing a .git directory
468 if test -d "$sm_path/.git"
469 then
470 echo >&2 "$(eval_gettext "Submodule work tree '\$displaypath' contains a .git directory")"
471 die "$(eval_gettext "(use 'rm -rf' if you really want to remove it including all of its history)")"
472 fi
473
474 if test -z "$force"
475 then
476 git rm -qn "$sm_path" ||
477 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
478 fi
479 rm -rf "$sm_path" &&
480 say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
481 say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
482 fi
483
484 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
485
486 # Remove the .git/config entries (unless the user already did it)
487 if test -n "$(git config --get-regexp submodule."$name\.")"
488 then
489 # Remove the whole section so we have a clean state when
490 # the user later decides to init this submodule again
491 url=$(git config submodule."$name".url)
492 git config --remove-section submodule."$name" 2>/dev/null &&
493 say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
494 fi
495 done
496}
497
498is_tip_reachable () (
499 sanitize_submodule_env &&
500 cd "$1" &&
501 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
502 test -z "$rev"
503)
504
505fetch_in_submodule () (
506 sanitize_submodule_env &&
507 cd "$1" &&
508 case "$2" in
509 '')
510 git fetch ;;
511 *)
512 git fetch $(get_default_remote) "$2" ;;
513 esac
514)
515
516#
517# Update each submodule path to correct revision, using clone and checkout as needed
518#
519# $@ = requested paths (default to all)
520#
521cmd_update()
522{
523 # parse $args after "submodule ... update".
524 while test $# -ne 0
525 do
526 case "$1" in
527 -q|--quiet)
528 GIT_QUIET=1
529 ;;
530 -i|--init)
531 init=1
532 ;;
533 --remote)
534 remote=1
535 ;;
536 -N|--no-fetch)
537 nofetch=1
538 ;;
539 -f|--force)
540 force=$1
541 ;;
542 -r|--rebase)
543 update="rebase"
544 ;;
545 --reference)
546 case "$2" in '') usage ;; esac
547 reference="--reference=$2"
548 shift
549 ;;
550 --reference=*)
551 reference="$1"
552 ;;
553 -m|--merge)
554 update="merge"
555 ;;
556 --recursive)
557 recursive=1
558 ;;
559 --checkout)
560 update="checkout"
561 ;;
562 --recommend-shallow)
563 recommend_shallow="--recommend-shallow"
564 ;;
565 --no-recommend-shallow)
566 recommend_shallow="--no-recommend-shallow"
567 ;;
568 --depth)
569 case "$2" in '') usage ;; esac
570 depth="--depth=$2"
571 shift
572 ;;
573 --depth=*)
574 depth=$1
575 ;;
576 -j|--jobs)
577 case "$2" in '') usage ;; esac
578 jobs="--jobs=$2"
579 shift
580 ;;
581 --jobs=*)
582 jobs=$1
583 ;;
584 --)
585 shift
586 break
587 ;;
588 -*)
589 usage
590 ;;
591 *)
592 break
593 ;;
594 esac
595 shift
596 done
597
598 if test -n "$init"
599 then
600 cmd_init "--" "$@" || return
601 fi
602
603 {
604 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
605 ${wt_prefix:+--prefix "$wt_prefix"} \
606 ${prefix:+--recursive-prefix "$prefix"} \
607 ${update:+--update "$update"} \
608 ${reference:+--reference "$reference"} \
609 ${depth:+--depth "$depth"} \
610 ${recommend_shallow:+"$recommend_shallow"} \
611 ${jobs:+$jobs} \
612 "$@" || echo "#unmatched"
613 } | {
614 err=
615 while read mode sha1 stage just_cloned sm_path
616 do
617 die_if_unmatched "$mode"
618
619 name=$(git submodule--helper name "$sm_path") || exit
620 url=$(git config submodule."$name".url)
621 branch=$(get_submodule_config "$name" branch master)
622 if ! test -z "$update"
623 then
624 update_module=$update
625 else
626 update_module=$(git config submodule."$name".update)
627 if test -z "$update_module"
628 then
629 update_module="checkout"
630 fi
631 fi
632
633 displaypath=$(relative_path "$prefix$sm_path")
634
635 if test $just_cloned -eq 1
636 then
637 subsha1=
638 update_module=checkout
639 else
640 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
641 git rev-parse --verify HEAD) ||
642 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
643 fi
644
645 if test -n "$remote"
646 then
647 if test -z "$nofetch"
648 then
649 # Fetch remote before determining tracking $sha1
650 (sanitize_submodule_env; cd "$sm_path" && git-fetch) ||
651 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
652 fi
653 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
654 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
655 git rev-parse --verify "${remote_name}/${branch}") ||
656 die "$(eval_gettext "Unable to find current ${remote_name}/${branch} revision in submodule path '\$sm_path'")"
657 fi
658
659 if test "$subsha1" != "$sha1" || test -n "$force"
660 then
661 subforce=$force
662 # If we don't already have a -f flag and the submodule has never been checked out
663 if test -z "$subsha1" && test -z "$force"
664 then
665 subforce="-f"
666 fi
667
668 if test -z "$nofetch"
669 then
670 # Run fetch only if $sha1 isn't present or it
671 # is not reachable from a ref.
672 is_tip_reachable "$sm_path" "$sha1" ||
673 fetch_in_submodule "$sm_path" ||
674 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
675
676 # Now we tried the usual fetch, but $sha1 may
677 # not be reachable from any of the refs
678 is_tip_reachable "$sm_path" "$sha1" ||
679 fetch_in_submodule "$sm_path" "$sha1" ||
680 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain $sha1. Direct fetching of that commit failed.")"
681 fi
682
683 must_die_on_failure=
684 case "$update_module" in
685 checkout)
686 command="git checkout $subforce -q"
687 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
688 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
689 ;;
690 rebase)
691 command="git rebase"
692 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
693 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
694 must_die_on_failure=yes
695 ;;
696 merge)
697 command="git merge"
698 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
699 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
700 must_die_on_failure=yes
701 ;;
702 !*)
703 command="${update_module#!}"
704 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
705 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
706 must_die_on_failure=yes
707 ;;
708 *)
709 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
710 esac
711
712 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
713 then
714 say "$say_msg"
715 elif test -n "$must_die_on_failure"
716 then
717 die_with_status 2 "$die_msg"
718 else
719 err="${err};$die_msg"
720 continue
721 fi
722 fi
723
724 if test -n "$recursive"
725 then
726 (
727 prefix=$(relative_path "$prefix$sm_path/")
728 wt_prefix=
729 sanitize_submodule_env
730 cd "$sm_path" &&
731 eval cmd_update
732 )
733 res=$?
734 if test $res -gt 0
735 then
736 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
737 if test $res -eq 1
738 then
739 err="${err};$die_msg"
740 continue
741 else
742 die_with_status $res "$die_msg"
743 fi
744 fi
745 fi
746 done
747
748 if test -n "$err"
749 then
750 OIFS=$IFS
751 IFS=';'
752 for e in $err
753 do
754 if test -n "$e"
755 then
756 echo >&2 "$e"
757 fi
758 done
759 IFS=$OIFS
760 exit 1
761 fi
762 }
763}
764
765set_name_rev () {
766 revname=$( (
767 sanitize_submodule_env
768 cd "$1" && {
769 git describe "$2" 2>/dev/null ||
770 git describe --tags "$2" 2>/dev/null ||
771 git describe --contains "$2" 2>/dev/null ||
772 git describe --all --always "$2"
773 }
774 ) )
775 test -z "$revname" || revname=" ($revname)"
776}
777#
778# Show commit summary for submodules in index or working tree
779#
780# If '--cached' is given, show summary between index and given commit,
781# or between working tree and given commit
782#
783# $@ = [commit (default 'HEAD'),] requested paths (default all)
784#
785cmd_summary() {
786 summary_limit=-1
787 for_status=
788 diff_cmd=diff-index
789
790 # parse $args after "submodule ... summary".
791 while test $# -ne 0
792 do
793 case "$1" in
794 --cached)
795 cached="$1"
796 ;;
797 --files)
798 files="$1"
799 ;;
800 --for-status)
801 for_status="$1"
802 ;;
803 -n|--summary-limit)
804 summary_limit="$2"
805 isnumber "$summary_limit" || usage
806 shift
807 ;;
808 --summary-limit=*)
809 summary_limit="${1#--summary-limit=}"
810 isnumber "$summary_limit" || usage
811 ;;
812 --)
813 shift
814 break
815 ;;
816 -*)
817 usage
818 ;;
819 *)
820 break
821 ;;
822 esac
823 shift
824 done
825
826 test $summary_limit = 0 && return
827
828 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
829 then
830 head=$rev
831 test $# = 0 || shift
832 elif test -z "$1" || test "$1" = "HEAD"
833 then
834 # before the first commit: compare with an empty tree
835 head=$(git hash-object -w -t tree --stdin </dev/null)
836 test -z "$1" || shift
837 else
838 head="HEAD"
839 fi
840
841 if [ -n "$files" ]
842 then
843 test -n "$cached" &&
844 die "$(gettext "The --cached option cannot be used with the --files option")"
845 diff_cmd=diff-files
846 head=
847 fi
848
849 cd_to_toplevel
850 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
851 # Get modified modules cared by user
852 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
853 sane_egrep '^:([0-7]* )?160000' |
854 while read mod_src mod_dst sha1_src sha1_dst status sm_path
855 do
856 # Always show modules deleted or type-changed (blob<->module)
857 if test "$status" = D || test "$status" = T
858 then
859 printf '%s\n' "$sm_path"
860 continue
861 fi
862 # Respect the ignore setting for --for-status.
863 if test -n "$for_status"
864 then
865 name=$(git submodule--helper name "$sm_path")
866 ignore_config=$(get_submodule_config "$name" ignore none)
867 test $status != A && test $ignore_config = all && continue
868 fi
869 # Also show added or modified modules which are checked out
870 GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
871 printf '%s\n' "$sm_path"
872 done
873 )
874
875 test -z "$modules" && return
876
877 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
878 sane_egrep '^:([0-7]* )?160000' |
879 cut -c2- |
880 while read mod_src mod_dst sha1_src sha1_dst status name
881 do
882 if test -z "$cached" &&
883 test $sha1_dst = 0000000000000000000000000000000000000000
884 then
885 case "$mod_dst" in
886 160000)
887 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
888 ;;
889 100644 | 100755 | 120000)
890 sha1_dst=$(git hash-object $name)
891 ;;
892 000000)
893 ;; # removed
894 *)
895 # unexpected type
896 eval_gettextln "unexpected mode \$mod_dst" >&2
897 continue ;;
898 esac
899 fi
900 missing_src=
901 missing_dst=
902
903 test $mod_src = 160000 &&
904 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
905 missing_src=t
906
907 test $mod_dst = 160000 &&
908 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
909 missing_dst=t
910
911 display_name=$(relative_path "$name")
912
913 total_commits=
914 case "$missing_src,$missing_dst" in
915 t,)
916 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
917 ;;
918 ,t)
919 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
920 ;;
921 t,t)
922 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
923 ;;
924 *)
925 errmsg=
926 total_commits=$(
927 if test $mod_src = 160000 && test $mod_dst = 160000
928 then
929 range="$sha1_src...$sha1_dst"
930 elif test $mod_src = 160000
931 then
932 range=$sha1_src
933 else
934 range=$sha1_dst
935 fi
936 GIT_DIR="$name/.git" \
937 git rev-list --first-parent $range -- | wc -l
938 )
939 total_commits=" ($(($total_commits + 0)))"
940 ;;
941 esac
942
943 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
944 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
945 if test $status = T
946 then
947 blob="$(gettext "blob")"
948 submodule="$(gettext "submodule")"
949 if test $mod_dst = 160000
950 then
951 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
952 else
953 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
954 fi
955 else
956 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
957 fi
958 if test -n "$errmsg"
959 then
960 # Don't give error msg for modification whose dst is not submodule
961 # i.e. deleted or changed to blob
962 test $mod_dst = 160000 && echo "$errmsg"
963 else
964 if test $mod_src = 160000 && test $mod_dst = 160000
965 then
966 limit=
967 test $summary_limit -gt 0 && limit="-$summary_limit"
968 GIT_DIR="$name/.git" \
969 git log $limit --pretty='format: %m %s' \
970 --first-parent $sha1_src...$sha1_dst
971 elif test $mod_dst = 160000
972 then
973 GIT_DIR="$name/.git" \
974 git log --pretty='format: > %s' -1 $sha1_dst
975 else
976 GIT_DIR="$name/.git" \
977 git log --pretty='format: < %s' -1 $sha1_src
978 fi
979 echo
980 fi
981 echo
982 done
983}
984#
985# List all submodules, prefixed with:
986# - submodule not initialized
987# + different revision checked out
988#
989# If --cached was specified the revision in the index will be printed
990# instead of the currently checked out revision.
991#
992# $@ = requested paths (default to all)
993#
994cmd_status()
995{
996 # parse $args after "submodule ... status".
997 while test $# -ne 0
998 do
999 case "$1" in
1000 -q|--quiet)
1001 GIT_QUIET=1
1002 ;;
1003 --cached)
1004 cached=1
1005 ;;
1006 --recursive)
1007 recursive=1
1008 ;;
1009 --)
1010 shift
1011 break
1012 ;;
1013 -*)
1014 usage
1015 ;;
1016 *)
1017 break
1018 ;;
1019 esac
1020 shift
1021 done
1022
1023 git submodule--helper list --prefix "$wt_prefix" "$@" |
1024 while read mode sha1 stage sm_path
1025 do
1026 die_if_unmatched "$mode"
1027 name=$(git submodule--helper name "$sm_path") || exit
1028 url=$(git config submodule."$name".url)
1029 displaypath=$(relative_path "$prefix$sm_path")
1030 if test "$stage" = U
1031 then
1032 say "U$sha1 $displaypath"
1033 continue
1034 fi
1035 if test -z "$url" ||
1036 {
1037 ! test -d "$sm_path"/.git &&
1038 ! test -f "$sm_path"/.git
1039 }
1040 then
1041 say "-$sha1 $displaypath"
1042 continue;
1043 fi
1044 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
1045 then
1046 set_name_rev "$sm_path" "$sha1"
1047 say " $sha1 $displaypath$revname"
1048 else
1049 if test -z "$cached"
1050 then
1051 sha1=$(sanitize_submodule_env; cd "$sm_path" && git rev-parse --verify HEAD)
1052 fi
1053 set_name_rev "$sm_path" "$sha1"
1054 say "+$sha1 $displaypath$revname"
1055 fi
1056
1057 if test -n "$recursive"
1058 then
1059 (
1060 prefix="$displaypath/"
1061 sanitize_submodule_env
1062 wt_prefix=
1063 cd "$sm_path" &&
1064 eval cmd_status
1065 ) ||
1066 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
1067 fi
1068 done
1069}
1070#
1071# Sync remote urls for submodules
1072# This makes the value for remote.$remote.url match the value
1073# specified in .gitmodules.
1074#
1075cmd_sync()
1076{
1077 while test $# -ne 0
1078 do
1079 case "$1" in
1080 -q|--quiet)
1081 GIT_QUIET=1
1082 shift
1083 ;;
1084 --recursive)
1085 recursive=1
1086 shift
1087 ;;
1088 --)
1089 shift
1090 break
1091 ;;
1092 -*)
1093 usage
1094 ;;
1095 *)
1096 break
1097 ;;
1098 esac
1099 done
1100 cd_to_toplevel
1101 git submodule--helper list --prefix "$wt_prefix" "$@" |
1102 while read mode sha1 stage sm_path
1103 do
1104 die_if_unmatched "$mode"
1105 name=$(git submodule--helper name "$sm_path")
1106 url=$(git config -f .gitmodules --get submodule."$name".url)
1107
1108 # Possibly a url relative to parent
1109 case "$url" in
1110 ./*|../*)
1111 # rewrite foo/bar as ../.. to find path from
1112 # submodule work tree to superproject work tree
1113 up_path="$(printf '%s\n' "$sm_path" | sed "s/[^/][^/]*/../g")" &&
1114 # guarantee a trailing /
1115 up_path=${up_path%/}/ &&
1116 # path from submodule work tree to submodule origin repo
1117 sub_origin_url=$(git submodule--helper resolve-relative-url "$url" "$up_path") &&
1118 # path from superproject work tree to submodule origin repo
1119 super_config_url=$(git submodule--helper resolve-relative-url "$url") || exit
1120 ;;
1121 *)
1122 sub_origin_url="$url"
1123 super_config_url="$url"
1124 ;;
1125 esac
1126
1127 if git config "submodule.$name.url" >/dev/null 2>/dev/null
1128 then
1129 displaypath=$(relative_path "$prefix$sm_path")
1130 say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
1131 git config submodule."$name".url "$super_config_url"
1132
1133 if test -e "$sm_path"/.git
1134 then
1135 (
1136 sanitize_submodule_env
1137 cd "$sm_path"
1138 remote=$(get_default_remote)
1139 git config remote."$remote".url "$sub_origin_url"
1140
1141 if test -n "$recursive"
1142 then
1143 prefix="$prefix$sm_path/"
1144 eval cmd_sync
1145 fi
1146 )
1147 fi
1148 fi
1149 done
1150}
1151
1152# This loop parses the command line arguments to find the
1153# subcommand name to dispatch. Parsing of the subcommand specific
1154# options are primarily done by the subcommand implementations.
1155# Subcommand specific options such as --branch and --cached are
1156# parsed here as well, for backward compatibility.
1157
1158while test $# != 0 && test -z "$command"
1159do
1160 case "$1" in
1161 add | foreach | init | deinit | update | status | summary | sync)
1162 command=$1
1163 ;;
1164 -q|--quiet)
1165 GIT_QUIET=1
1166 ;;
1167 -b|--branch)
1168 case "$2" in
1169 '')
1170 usage
1171 ;;
1172 esac
1173 branch="$2"; shift
1174 ;;
1175 --cached)
1176 cached="$1"
1177 ;;
1178 --)
1179 break
1180 ;;
1181 -*)
1182 usage
1183 ;;
1184 *)
1185 break
1186 ;;
1187 esac
1188 shift
1189done
1190
1191# No command word defaults to "status"
1192if test -z "$command"
1193then
1194 if test $# = 0
1195 then
1196 command=status
1197 else
1198 usage
1199 fi
1200fi
1201
1202# "-b branch" is accepted only by "add"
1203if test -n "$branch" && test "$command" != add
1204then
1205 usage
1206fi
1207
1208# "--cached" is accepted only by "status" and "summary"
1209if test -n "$cached" && test "$command" != status && test "$command" != summary
1210then
1211 usage
1212fi
1213
1214"cmd_$command" "$@"